<template>
  <v-content>
    <v-container fluid>
      <v-layout justify-center>
        <v-card id="daily-rates-form">
          <v-toolbar color="blue darken-3" dark>
            <v-toolbar-title>Fill you daily rates to calculate monthly salary</v-toolbar-title>
          </v-toolbar>
          <v-card-text>
            <v-form ref="form">
              <template v-for="(country, index) in countries">
                <v-layout row :key="country.name">
                  <v-text-field
                    v-model="country.dailyRate"
                    :key="country.name"
                    :label="country.name"
                    :suffix="country.currency.code"
                    :rules="onlyNumbers"/>
                  <template v-if="resultsPresent">
                    <span class="equal-sign">=</span>
                    <p class="salary-placeholder">{{salaries[index]}} PLN</p>
                  </template>
                </v-layout>
              </template>
            </v-form>
          </v-card-text>
          <v-divider class="mt-5"/>
          <v-card-actions>
            <v-btn flat @click="clearForm">Cancel</v-btn>
            <v-spacer/>
            <v-slide-x-reverse-transition>
              <v-tooltip left v-if="formHasErrors">
                <v-btn icon @click="clearForm" slot="activator">
                  <v-icon>refresh</v-icon>
                </v-btn>
                <span>Refresh form</span>
              </v-tooltip>
            </v-slide-x-reverse-transition>
            <v-btn @click="submitForm" color="primary" flat>Submit</v-btn>
          </v-card-actions>
        </v-card>
      </v-layout>
    </v-container>
  </v-content>
</template>

<script>
import backend from '../services/backend'

export default {
  name: 'SalaryCalculator',
  data () {
    return {
      countries: [],
      salaries: [],
      formHasErrors: false,
      resultsPresent: false,
      onlyNumbers: [
        (v) => !!v || 'Daily rate should be filled',
        (v) => !isNaN(v) || 'This input should contains only numbers!'
      ]
    }
  },
  methods: {
    submitForm: function (e) {
      if (this.$refs.form.validate()) {
        this.salaries = []

        let salaryPromises = this.countries
          .map(c => backend.calculateSalary(c.dailyRate, c.currency.code))

        Promise.all(salaryPromises)
          .then(values => {
            this.resultsPresent = true
            values.forEach(s => this.salaries.push(s.salaryInPLN))
          })
      } else {
        this.formHasErrors = true
      }
    },
    clearForm: function (e) {
      this.resultsPresent = false
      this.formHasErrors = false
      this.$refs.form.reset()
    }
  },
  created () {
    backend.getCountries()
      .then(response => {
        this.countries = response._embedded.countries
      })
  }
}
</script>

<style scoped>
  .equal-sign {
    width: 40px;
    text-align: center;
    font-size: 16px;
    padding-top: 22px;
  }
  .salary-placeholder {
    font-size: 16px;
    padding-top: 22px;
    border-bottom: 1px solid;
    margin-bottom: 0;
    height: 49px;
  }
</style>
